<?php
require 'vendor/autoload.php';

use Spatie\SimpleExcel\SimpleExcelReader;

include 'config.php';
function getCustomerHistory($orderID)
{
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://api.konnektive.com/customer/history/?loginId=farazdev&password=farazdev&customerId=' . $orderID,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);
    curl_close($curl);
    return  json_decode($response, true);
}
function getChampCustomerHistory($customerID)
{
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://api.checkoutchamp.com/customer/history/?loginId=farazdev&password=farazdev&customerId=' . $customerID,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);
    curl_close($curl);
    return  json_decode($response, true);
}
function import_orders($file_name)
{
    $customers = SimpleExcelReader::create($file_name)->getRows();
    $customers->each(function (array $customer) {


        if (!empty($customer['Campaign Id']) && $customer['Campaign Id'] != 12) {
            $customer_data = order_data($customer);

            $checkCustomer = find_customer('customers', $customer_data['email']);
            //     echo "<pre>";
            // echo($checkCustomer);
            // exit;

            if (empty($checkCustomer)) {

                create_customer('customers', $customer_data);
            } else {
                echo "customer duplicate found" . $customer_data['email'] . "<br>";
            }
        }
    });
}

function order_data($customer, $is_champ = false)
{
    // echo "<pre>";
    // print_r($customer);
    // exit;
    $data = array();

    if ($is_champ) {
        if (!empty($customer['Order Id'])) {
            $data['order_id'] = $customer['Order Id'];
        }
        //            if(!empty($customer['nextBillDate'])){
        //                $data['nextBillDate'] = $customer['nextBillDate'];
        //            }
        if (!empty($customer['customerId'])) {
            $data['customer_id'] = $customer['customerId'];
        }
        if (!empty($customer['purchaseId'])) {
            $data['purchase_id'] = $customer['purchaseId'];
        }
        //            if(!empty($customer['Date'])){
        //                $data['order_date'] = $customer['Date'];
        //            }

    } else {
        if (!empty($customer['Order Id'])) {
            $data['orderId'] = $customer['Order Id'];
        }
        if (!empty($customer['Customer Number'])) {
            $data['customerId'] = $customer['Customer Number'];
        }
        if (!empty($customer['Bill First'])) {
            $data['firstName'] = $customer['Bill First'];
        }
        if (!empty($customer['Bill Last'])) {
            $data['lastName'] = $customer['Bill Last'];
        }
        if (!empty($customer['Bill Email'])) {
            $data['email'] = $customer['Bill Email'];
        }
        // if (!empty($customer['Campaign Id'])) {
        //     $data['campaignId'] = $customer['Campaign Id'];
        // }

    }


    return $data;
}

function find_customer($table, $email)
{
    global $db_conn;
    $sql = "SELECT * FROM $table WHERE email='" . $email . "'";
    $result = $db_conn->query($sql);
    return $result->fetch_assoc();
}
function find_champ_customer($table, $customer_id, $order_id)
{
    global $db_conn;
    $sql = "SELECT * FROM $table WHERE customer_id='" . $customer_id . "'";
    $result = $db_conn->query($sql);
    return $result->fetch_assoc();
}

function create_customer($table, $data)
{
    global $db_conn;
    $keys = array_keys($data);
    $keys = implode(",", $keys);

    $values = value_to_string($data);
    $sql = "INSERT INTO $table ($keys)
VALUES ($values)";
    $result = $db_conn->query($sql);

    $last_id = $db_conn->insert_id;
    return $last_id;
}

function value_to_string($data)
{
    global $db_conn;
    $db_values_str = "";
    $current_iteration = 0;
    foreach ($data as $key => $item) {
        $item = $db_conn->real_escape_string($item);
        $db_values_str .= '"';
        $db_values_str .= $item;
        $db_values_str .= '"';
        if ((count($data) - 1) !== $current_iteration) {
            $db_values_str .= ',';
        }
        $current_iteration++;
    }
    return $db_values_str;
}
function update_customer_order($table, $data, $customer_id)
{
    global $db_conn;
    $update_string = update_query_mapping($data);
    $sql = "UPDATE $table SET $update_string WHERE id='" . $customer_id . "'";
    $result = $db_conn->query($sql);
}

function update_query_mapping($data)
{
    global $db_conn;
    $db_values_str = "";
    $current_iteration = 0;
    foreach ($data as $key => $item) {
        $item = $db_conn->real_escape_string($item);
        $db_values_str .= "$key = '$item'";
        if ((count($data) - 1) !== $current_iteration) {
            $db_values_str .= ',';
        }
        $current_iteration++;
    }
    return $db_values_str;
}

function get_all_orders_ids($limit)
{
    global $db_conn;
    $data = array();
    $sql = "SELECT * FROM `sticky_customers` where is_processed = 0 order by id desc limit $limit";
    $result = $db_conn->query($sql);
    if ($result->num_rows > 0) {
        // output data of each row
        while ($row = $result->fetch_assoc()) {

            $data[] = $row;
            // if (!empty($row['customer_id'])) {
            //     $data[$row['customer_id']] = $row['offer_id'];
            // }
        }
    }
    return $data;
}
function orderGet($limit)
{
    global $db_conn;
    $data = array();
    $sql = "SELECT * FROM `sticky_customers` where is_processed = 1 AND is_upsell_success = 1 AND is_gateway_changed = 0 order by id desc limit $limit";
    $result = $db_conn->query($sql);
    if ($result->num_rows > 0) {
        // output data of each row
        while ($row = $result->fetch_assoc()) {

            $data[] = $row;
            
        }
    }
    return $data;
}
function get_order($orderId)
{
    $loginId = "farazdev";
    $password = "farazdev";
    $curl = curl_init();

    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.checkoutchamp.com/order/query/?" . http_build_query([
            'loginId' => $loginId,
            'password' => $password,
            'customerId' => $orderId,

        ]),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    $json_data = json_decode($response, true);

    return $json_data;
}
function get_kk_order($orderId)
{
    $loginId = "mfaraz2";
    $password = "mfaraz2";
    $curl = curl_init();

    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.konnektive.com/order/query/?" . http_build_query([
            'loginId' => $loginId,
            'password' => $password,
            'orderId' => $orderId,
        ]),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    $json_data = json_decode($response, true);

    return $json_data;
}
function update_purchase($purchaseId, $product_id, $nextBillingDate)
{
    $loginId = "farazdev";
    $password = "farazdev";
    $mercahntId = 6;
    $nextBillingDate = date_create($nextBillingDate);
    $nextBillingDate =  date_format($nextBillingDate, "m/d/Y");
    $curl = curl_init();
    $updatedData = array(
        'loginId' => $loginId,
        'password' => $password,
        'purchaseId' => $purchaseId,
        //  'newMerchantId'=>$mercahntId,
        'productId' => $product_id,
        'productQty' => 1,
        // 'nextBillDate'=>$nextBillingDate
    );
    print_r($updatedData);
    //exit;
    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.checkoutchamp.com/purchase/update/?" . http_build_query($updatedData),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));


    $response = curl_exec($curl);


    curl_close($curl);



    $json_data = json_decode($response, true);
    print_r($json_data);
    //exit;
    return $json_data;
}

function customerHistory($customerID)
{
    $skipCustomer = array("REFUNDED", "BLACKLISTED", "CHARGEBACKED", "ORDER_CANCELLED");
    $userHistory = getChampCustomerHistory($customerID);
    if ($userHistory["result"] == "SUCCESS") {
        if (!empty($userHistory["message"]["data"])) {
            foreach ($userHistory["message"]["data"] as $history) {

                if (in_array($history["categoryType"], $skipCustomer) || ($history["categoryType"] == "RECYCLE_FAILED" && strpos($history["message"], "Recycle Attempt #2") !== false)) {
                    return array("status" => false, "reason" => $history["categoryType"]);
                    exit;
                }
            }
            return array("status" => true);
        }
    }
}

function import_champ_orders($file_name, $date)
{
    $customers = SimpleExcelReader::create($file_name)->getRows();
    $customers->each(function (array $customer) use ($date) {
        $customer_data = order_data($customer, true);
        //        print_r($customer_data);
        //        exit;
        //        $checkCustomer = find_champ_customer('champ_customers',$customer_data['customer_id'],$customer_data['order_id']);
        //        if(empty($checkCustomer)){
        //            $customer_data['nextBillDate'] = $date;
        //            echo "<pre>";
        //            print_r($customer_data);
        //            exit;
        create_customer('champ_customers', $customer_data);
        //   }
    });
}
function get_all_champ_orders_ids($limit)
{
    global $db_conn;
    $data = array();
    $sql = "SELECT * FROM `champ_customers` where `is_processed` = 0 order by id desc limit $limit";
    $result = $db_conn->query($sql);
    if ($result->num_rows > 0) {
        // output data of each row
        while ($row = $result->fetch_assoc()) {
            if (!empty($row['customer_id'])) {
                $data[] = $row;
            }
        }
    }
    return $data;
}
function update_order_by_id($table, $data, $id)
{
    global $db_conn;
    $update_string = update_query_mapping($data);
    $sql = "UPDATE $table SET $update_string WHERE id='" . $id . "'";
    $result = $db_conn->query($sql);
}

function get_kk_purchases($customerId)
{
    $loginId = "mfaraz2";
    $password = "mfaraz2";
    $curl = curl_init();

    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.konnektive.com/purchase/query/?" . http_build_query([
            'loginId' => $loginId,
            'password' => $password,
            'customerId' => $customerId,
        ]),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    $json_data = json_decode($response, true);

    return $json_data;
}

function update_kk_purchase($purchaseId, $product_id)
{
    $loginId = "mfaraz2";
    $password = "mfaraz2";
    //$p_id =

    $mercahntId = 5;
    $curl = curl_init();
    $updatedData = array(
        'loginId' => $loginId,
        'password' => $password,
        'purchaseId' => $purchaseId,
        'newMerchantId' => $mercahntId,
        //        'productId'=>$p_id,
    );
    //echo "<pre>";
    //print_r($updatedData);
    //    exit;
    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.konnektive.com/purchase/update/?" . http_build_query($updatedData),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    return array("post_data" => $updatedData, "response" => $response);
}

function get_champ_purchases($customerId)
{
    $loginId = "farazdev";
    $password = "farazdev";
    $curl = curl_init();

    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.konnektive.com/purchase/query/?" . http_build_query([
            'loginId' => $loginId,
            'password' => $password,
            'customerId' => $customerId,
        ]),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));


    $response = curl_exec($curl);


    curl_close($curl);



    $json_data = json_decode($response, true);

    return $json_data;
}

function addNewOffer($customerID)
{
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.checkoutchamp.com/purchase/query/?loginId=farazdev&password=farazdev&customerId=$customerID",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    // Decode the JSON response into a PHP array
    $data = json_decode($response, true);

    // Extract the relevant data
    $firstName = urlencode($data['message']['data'][0]['firstName']);
    $lastName = urlencode($data['message']['data'][0]['lastName']);
    $address1 = urlencode($data['message']['data'][0]['address1']);
    $address2 = urlencode($data['message']['data'][0]['address2']);
    $postalCode = urlencode($data['message']['data'][0]['postalCode']);
    $city = urlencode($data['message']['data'][0]['city']);
    $state = urlencode($data['message']['data'][0]['state']);
    $country = urlencode($data['message']['data'][0]['country']);
    $emailAddress = urlencode($data['message']['data'][0]['emailAddress']);
    $phoneNumber = urlencode($data['message']['data'][0]['phoneNumber']);
    $shipFirstName = urlencode($data['message']['data'][0]['shipFirstName']);
    $shipLastName = urlencode($data['message']['data'][0]['shipLastName']);
    $shipAddress1 = urlencode($data['message']['data'][0]['shipAddress1']);
    $shipAddress2 = urlencode($data['message']['data'][0]['shipAddress2']);
    $shipPostalCode = urlencode($data['message']['data'][0]['shipPostalCode']);
    $shipCity = urlencode($data['message']['data'][0]['shipCity']);
    $shipState = urlencode($data['message']['data'][0]['shipState']);
    $shipCountry = urlencode($data['message']['data'][0]['shipCountry']);
    $paySource = 'ACCTONFILE';
    $campaignId = '11';
    $product1_id = '117'; // PRODUCT ID
    $product1_qty = '1';
    $affId = '';
    //    exit;
    // Construct the populated URL
    $populatedUrl = "https://api.checkoutchamp.com/order/import/?loginId=farazdev&password=farazdev&firstName=$firstName&lastName=$lastName&address1=$address1&address2=$address2&postalCode=$postalCode&city=$city&state=$state&country=$country&emailAddress=$emailAddress&phoneNumber=$phoneNumber&shipFirstName=$shipFirstName&shipLastName=$shipLastName&shipAddress1=$shipAddress1&shipAddress2=$shipAddress2&shipPostalCode=$shipPostalCode&shipCity=$shipCity&shipState=$shipState&shipCountry=$shipCountry&paySource=$paySource&campaignId=$campaignId&product1_id=$product1_id&product1_qty=$product1_qty&affId=$affId";

    //echo $populatedUrl;exit;

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $populatedUrl,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    return json_decode($response, true);
}

function champ_gateway_update($purchaseId)
{
    $loginId = "farazdev";
    $password = "farazdev";
    $mercahntId = 7;

    $curl = curl_init();
    $updatedData = array(
        'loginId' => $loginId,
        'password' => $password,
        'purchaseId' => $purchaseId,
        'newMerchantId' => $mercahntId,
    );

    //exit;
    // Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.checkoutchamp.com/purchase/update/?" . http_build_query($updatedData),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    $json_data = json_decode($response, true);
    return $json_data;
}


function addUpSell($data)
{

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://unicornusainc.sticky.io/api/v1/new_upsell',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => json_encode($data),
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Authorization: Basic bWZhcmF6NzMzOlBRMzJ3VUp4M1RKNDNn'
        ),
    ));

     $response = curl_exec($curl);

    curl_close($curl);

    
    // echo $response;

    return $response;
}
function changeGateway($data)
{

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://unicornusainc.sticky.io/api/v2/subscriptions',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'PUT',
        CURLOPT_POSTFIELDS => json_encode($data),
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Authorization: Basic bWZhcmF6NzMzOlBRMzJ3VUp4M1RKNDNn'
        ),
    ));

    $response = curl_exec($curl);

    curl_close($curl);
//     $response = '{
//     "status": "SUCCESS"
// }';
    return $response;
}
function get_client_ip() {
    $ipaddress = '';
    if (getenv('HTTP_CLIENT_IP'))
        $ipaddress = getenv('HTTP_CLIENT_IP');
    else if(getenv('HTTP_X_FORWARDED_FOR'))
        $ipaddress = getenv('HTTP_X_FORWARDED_FOR');
    else if(getenv('HTTP_X_FORWARDED'))
        $ipaddress = getenv('HTTP_X_FORWARDED');
    else if(getenv('HTTP_FORWARDED_FOR'))
        $ipaddress = getenv('HTTP_FORWARDED_FOR');
    else if(getenv('HTTP_FORWARDED'))
       $ipaddress = getenv('HTTP_FORWARDED');
    else if(getenv('REMOTE_ADDR'))
        $ipaddress = getenv('REMOTE_ADDR');
    else
        $ipaddress = 'UNKNOWN';
    return $ipaddress;
}